package org.skywalking.apm.collector.worker.node.persistence;

import org.skywalking.apm.collector.actor.AbstractLocalSyncWorkerProvider;
import org.skywalking.apm.collector.actor.ClusterWorkerContext;
import org.skywalking.apm.collector.actor.LocalWorkerContext;
import org.skywalking.apm.collector.actor.selector.HashCodeSelector;
import org.skywalking.apm.collector.actor.selector.WorkerSelector;
import org.skywalking.apm.collector.worker.RecordPersistenceMember;
import org.skywalking.apm.collector.worker.node.NodeCompIndex;
import org.skywalking.apm.collector.worker.storage.PersistenceWorkerListener;

/**
 * @author pengys5
 */
public class NodeCompSave extends RecordPersistenceMember {

    NodeCompSave(org.skywalking.apm.collector.actor.Role role, ClusterWorkerContext clusterContext,
                 LocalWorkerContext selfContext) {
        super(role, clusterContext, selfContext);
    }

    @Override
    public String esIndex() {
        return NodeCompIndex.INDEX;
    }

    @Override
    public String esType() {
        return NodeCompIndex.TYPE_RECORD;
    }

    public static class Factory extends AbstractLocalSyncWorkerProvider<NodeCompSave> {
        @Override
        public Role role() {
            return Role.INSTANCE;
        }

        @Override
        public NodeCompSave workerInstance(ClusterWorkerContext clusterContext) {
            NodeCompSave worker = new NodeCompSave(role(), clusterContext, new LocalWorkerContext());
            PersistenceWorkerListener.INSTANCE.register(worker);
            return worker;
        }
    }

    public enum Role implements org.skywalking.apm.collector.actor.Role {
        INSTANCE;

        @Override
        public String roleName() {
            return NodeCompSave.class.getSimpleName();
        }

        @Override
        public WorkerSelector workerSelector() {
            return new HashCodeSelector();
        }
    }
}
